<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPalletReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfPalletReportItem extends AbstractStructArrayBase
{
    /**
     * The PalletReportItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PalletReportItem[]
     */
    public $PalletReportItem;
    /**
     * Constructor method for ArrayOfPalletReportItem
     * @uses ArrayOfPalletReportItem::setPalletReportItem()
     * @param \StructType\PalletReportItem[] $palletReportItem
     */
    public function __construct(array $palletReportItem = array())
    {
        $this
            ->setPalletReportItem($palletReportItem);
    }
    /**
     * Get PalletReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PalletReportItem[]|null
     */
    public function getPalletReportItem()
    {
        return isset($this->PalletReportItem) ? $this->PalletReportItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPalletReportItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPalletReportItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePalletReportItemForArrayConstraintsFromSetPalletReportItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPalletReportItemPalletReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfPalletReportItemPalletReportItemItem instanceof \StructType\PalletReportItem) {
                $invalidValues[] = is_object($arrayOfPalletReportItemPalletReportItemItem) ? get_class($arrayOfPalletReportItemPalletReportItemItem) : sprintf('%s(%s)', gettype($arrayOfPalletReportItemPalletReportItemItem), var_export($arrayOfPalletReportItemPalletReportItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PalletReportItem property can only contain items of type \StructType\PalletReportItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PalletReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PalletReportItem[] $palletReportItem
     * @return \ArrayType\ArrayOfPalletReportItem
     */
    public function setPalletReportItem(array $palletReportItem = array())
    {
        // validation for constraint: array
        if ('' !== ($palletReportItemArrayErrorMessage = self::validatePalletReportItemForArrayConstraintsFromSetPalletReportItem($palletReportItem))) {
            throw new \InvalidArgumentException($palletReportItemArrayErrorMessage, __LINE__);
        }
        if (is_null($palletReportItem) || (is_array($palletReportItem) && empty($palletReportItem))) {
            unset($this->PalletReportItem);
        } else {
            $this->PalletReportItem = $palletReportItem;
        }
        return $this;
    }
    /**
     * Add item to PalletReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\PalletReportItem $item
     * @return \ArrayType\ArrayOfPalletReportItem
     */
    public function addToPalletReportItem(\StructType\PalletReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PalletReportItem) {
            throw new \InvalidArgumentException(sprintf('The PalletReportItem property can only contain items of type \StructType\PalletReportItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PalletReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PalletReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PalletReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PalletReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PalletReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PalletReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PalletReportItem
     */
    public function getAttributeName()
    {
        return 'PalletReportItem';
    }
}
